

grammar test3
{
terminals
   a b c

nonterminals
   S B C SyntaxError

error SyntaxError
start S
type int

principles

	.S : .a S
	    ;

	a.S : 	a. a S B C
	    |   a. B C
	    ;

	a.B : a .b	;
	b.B : b .b    	;
	B C.B : .B B C	;

	C .C B : C B C. ;
	B C.C : .B C C	;
	b.C B : b B C.	;

	c.C : c .c	;
	b.C : b .c	;

	.SyntaxError : . {% std::cout << "Syntax error" << std::endl; %}
      ;

{%
	public:
		void parse(int i)
		{
			run(i);
		}
%}
}

source
{%
#include <iostream>

using namespace std;

void test3::getToken(Symbol<int> &s) const
{
	char c;
	cin >> c;

	s.attr  = 0;

	if (c == 'a' || c == 'A')
		s.id = test3::a;
	else if (c == 'b' || c == 'B')
		s.id = test3::b;
	else if (c == 'c' || c == 'C')
		s.id = test3::c;
	else
		s.id = 0;

}

main()
{
   test3 parser;

   parser.parse(0);
}

%}
