/*
	Copyright (c) 2001 Maurice Gittens <maurce@gittens.nl>

   This software is distributed under the GNU General
   Public License.
	See the file COPYING for more information on usage and
	redistribution of this file and for a DISCLAIMER OF ALL
	WARRANTIES.

	Written by Maurice Gittens <maurice@gittens.nl>.
*/

#include <tiny_parserGenerator.h>
#include <iostream>

using namespace std;

int tiny_parserGenerator::run()
{
   parser();

   if (!scanner.getErrorCount())
   {
      symbolProcessor();
   }

   if (getPrintTables())
   {
      cerr << "\n*** contents of the symboltable ***\n";
      symbolProcessor.printSymbolTable();
   }

   if (getPrintActions())
   {
      cerr << "\n*** actions ***\n";
      symbolProcessor.printActions();
   }

   if (!scanner.getErrorCount())
      codeGenerator();

   unsigned ec = scanner.getErrorCount();
   unsigned wc = scanner.getWarningCount();
   cout << ec << " error" << (ec == 1 ? "" : "s")
        << " and " << wc << " warning" << (wc == 1 ? "" : "s")
        << " reported" << endl;

   return ec;
}
