/*
	Copyright (c) 2001 Maurice Gittens <maurce@gittens.nl>

   This software is distributed under the GNU General
   Public License.
	See the file COPYING for more information on usage and
	redistribution of this file and for a DISCLAIMER OF ALL
	WARRANTIES.

	Written by Maurice Gittens <maurice@gittens.nl>.
*/

#ifndef TINY_UTIL_SEEN
#define TINY_UTIL_SEEN

const unsigned TINY_BITS_USED                      = 3;
const unsigned TINY_BITS_MASK                      = 0x0007;
const unsigned TINY_NONTERMINAL_MASK               = 0x0001;
const unsigned TINY_GENERIC_MASK                   = 0x0002;
const unsigned TINY_TERMINAL_MASK                  = 0x0003;
const unsigned TINY_ACTION_MASK                    = 0x0004;
const unsigned SELECTIONSET_MASK		     		      = 0x0005;
const unsigned VARIABLE_MASK		     		         = 0x0006;
const unsigned ALWAYS_REWRITE		     		         = 0x0007;

inline unsigned makeGeneric(unsigned i)       	{ return (i << TINY_BITS_USED) | TINY_GENERIC_MASK; }
inline unsigned makeAction(unsigned i)       	{ return (i << TINY_BITS_USED) | TINY_ACTION_MASK; }
inline unsigned makeTerminal(unsigned i)          { return (i << TINY_BITS_USED) | TINY_TERMINAL_MASK; }
inline unsigned makeNonTerminal(unsigned i)  	{ return (i << TINY_BITS_USED) | TINY_NONTERMINAL_MASK; }
inline unsigned makeVariable(unsigned i)  	{ return (i << TINY_BITS_USED) | VARIABLE_MASK; }
inline unsigned isGeneric(unsigned i)         	{ return (i & TINY_BITS_MASK) == TINY_GENERIC_MASK; }
inline unsigned isAction(unsigned i)         	{ return (i & TINY_BITS_MASK) == TINY_ACTION_MASK; }
inline unsigned isTerminal(unsigned i)       	{ return (i & TINY_BITS_MASK) == TINY_TERMINAL_MASK; }
inline unsigned isNonTerminal(unsigned i)    	{ return (i & TINY_BITS_MASK) <= TINY_GENERIC_MASK; }
inline unsigned isSelectionSet(unsigned i) 	{ return (i & TINY_BITS_MASK) == SELECTIONSET_MASK; }
inline unsigned isVariable(unsigned i) 	{ return (i & TINY_BITS_MASK) == VARIABLE_MASK; }
inline unsigned isAlwaysRewrite(unsigned i) 	{ return (i & TINY_BITS_MASK) == ALWAYS_REWRITE; }

inline unsigned makeId(unsigned i)                { return i >> TINY_BITS_USED; }
inline unsigned symbolType(unsigned i)       	{ return i & TINY_BITS_MASK; }

#endif


